"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelNodeAction = void 0;

var _path = require("path");

var _actionConfigs = require("../../../configs/actionConfigs");

var _exec = require("../../cmd/exec");

var _getConfigPath = require("../../utils/getConfigPath");

var _getFirstExistingFile = require("../../utils/getFirstExistingFile");

const babelNodeAction = async ({
  root,
  cwd,
  log
}, {
  script,
  watch
}) => {
  const configPath = await (0, _getConfigPath.getBabelConfigPath)({
    root,
    cwd
  });
  const cmd = (0, _path.join)(root, watch ? _actionConfigs.babelCommandWatch : _actionConfigs.babelCommandNode);
  const args = []; // options

  args.push('--extensions', _actionConfigs.babelExtensions);
  args.push('--config-file', configPath); // script

  args.push(script ?? (await (0, _getFirstExistingFile.getFirstExistingFile)({
    cwd,
    files: _actionConfigs.babelScriptFiles
  })));
  log.info(`Run babel-${watch ? 'watch' : 'node'}`);
  await (0, _exec.exec)({
    cmd,
    args,
    cwd,
    log,
    withInteraction: true,
    withDirectOutput: true
  });
};

exports.babelNodeAction = babelNodeAction;