"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWorkspaces = void 0;

var _path = require("path");

var _toolLib = require("@kettil/tool-lib");

var _glob = require("glob");

const getWorkspaces = root => {
  /* eslint-disable-next-line max-len -- see next line */

  /* eslint-disable-next-line @typescript-eslint/no-var-requires, node/global-require, import/no-dynamic-require -- root path is unknown */
  const packageJson = require(`./${(0, _path.join)((0, _path.relative)(__dirname, root), './package.json')}`);

  if (!(0, _toolLib.isObject)(packageJson)) {
    return {};
  }

  const {
    workspaces
  } = packageJson;

  if (!(0, _toolLib.isArray)(workspaces)) {
    return {};
  }

  const paths = (0, _toolLib.uniqueArray)(workspaces.filter(workspace => typeof workspace === 'string').flatMap(workspace => _glob.glob.sync(`${workspace.replace(/\/+$/, '')}/`)).map(path => path.replace(/\/$/, '').replace(/^\./, '<rootDir>')).sort());
  return Object.fromEntries(paths.map(path => [(0, _path.basename)(path), path]));
};

exports.getWorkspaces = getWorkspaces;